//
//  AppDelegate.m
//  Hello
//
//  Created by Clemens Wagner on 02.08.14.
//  Copyright (c) 2014 Clemens Wagner. All rights reserved.
//

#import "AppDelegate.h"
#include <dlfcn.h>

@interface AppDelegate ()

@end

#if USE_DLOPEN
void (*logWorld)();
#else
void logWorld();
#endif

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
#if USE_DLOPEN
    [self loadLibraryWithName:@"libHello"];
#endif
#ifndef USE_STATIC
    logWorld();
#endif
    return YES;
}

- (void)loadLibraryWithName:(NSString *)inName {
    NSString *thePath = [[NSBundle mainBundle] pathForResource:inName ofType:@"dylib"];
    void *theLib = dlopen([thePath fileSystemRepresentation], RTLD_LAZY | RTLD_LOCAL | RTLD_FIRST);

    if(theLib == NULL) {
        NSLog(@"dlerror: %s", dlerror());
    }
    else {
        NSLog(@"Lib: 0x%p", theLib);
#if USE_DLOPEN
        logWorld = dlsym(theLib, "logWorld");
#endif
#ifndef USE_STATIC
        NSLog(@"logWorld: %p", logWorld);
#endif
    }
}

@end
